Package: ternarynet
Version: 1.56.0
Date: 2024-02-19
Title: Ternary Network Estimation
Description: Gene-regulatory network (GRN) modeling seeks to infer 
        dependencies between genes and thereby provide insight into 
        the regulatory relationships that exist within a cell. 
        This package provides a computational Bayesian approach to
        GRN estimation from perturbation experiments using a ternary 
        network model, in which gene expression is discretized into 
        one of 3 states: up, unchanged, or down). The ternarynet package
        includes a parallel implementation of the replica exchange Monte 
        Carlo algorithm for fitting network models, using MPI.
Author: Matthew N. McCall <mccallm@gmail.com>, 
        Anthony Almudevar <Anthony_Alumudevar@urmc.rochester.edu>,
        David Burton <David_Burton@urmc.rochester.edu>,
        Harry Stern <harry.stern@rochester.edu>
Authors@R: c(
  person("McCall","Matthew", 
         email="mccallm@gmail.com",
         role=c("aut","cre")),
  person("Almudevar","Anthony",
         email="Anthony_Almudevar@urmc.rochester.edu",
         role=c("aut")),
  person("Burton","David",
         email="David_Burton@urmc.rochester.edu",
         role=c("aut")),
  person("Stern","Harry",
         email="harry.stern@rochester.edu",
         role=c("aut")))
Depends: R (>= 4.0)
Imports: utils, igraph, methods, graphics, stats, BiocParallel
Suggests: testthat
Enhances: Rmpi, snow
License: GPL (>= 2)
biocViews: Software, CellBiology, GraphAndNetwork, Network, Bayesian
NeedsCompilation: yes
Packaged: 2026-04-29 01:08:13 UTC; biocbuild
Maintainer: McCall N. Matthew <mccallm@gmail.com>
git_url: https://git.bioconductor.org/packages/ternarynet
git_branch: RELEASE_3_23
git_last_commit: 8a6bb8d
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28

plotPost <- function(ternaryPost, threshold = 0.5, type = "interactive", ...) {
  grph <- graphPosterior(ternaryPost)
  el <- which(grph[, -1] > threshold, arr.ind = TRUE)[, c(2, 1)]
  if (type == "static") plot(graph.edgelist(el), ...)
  if (type == "interactive") tkplot(graph.edgelist(el), ...)
}

attractorSummary <- function(tpost, post.prob.limit = 0.01, wildtype = TRUE) {
  perturbationObj(tpost) <- perturbationObj(tpost) + 2
  steadyStateObj(tpost) <- round(steadyStateObj(tpost)) + 2

  nOutcomes <- 3
  n.genes <- nrow(perturbationObj(tpost))
  n.sample <- ncol(perturbationObj(tpost))
  RowNames <- seq_len(n.genes)
  ColNames <- seq_len(n.sample)
  forced.gene.list <- NULL
  for (i in seq_len(n.sample)) {
    fg <- seq_len(n.genes)[perturbationObj(tpost)[, i] != 2]
    fs <- perturbationObj(tpost)[fg, i]
    forced.gene.list <- append(
      forced.gene.list,
      list(list(forced.genes = fg, forced.states = fs))
    )
  }
  initial.state.obj <- list(forced.gene.list = forced.gene.list, initial.states = steadyStateObj(tpost))
  attr <- attractor.posterior.2(tpost, initial.state.obj, wt = wildtype)
  post.attr.summary.list <- NULL
  for (i in seq_len(n.sample)) {
    post.attr.summary.list <- append(post.attr.summary.list, list(list(obs = steadyStateObj(tpost)[, i] - nOutcomes + 1, attr = condense.attractor(attr[[i]], post.prob.limit))))
  }
  post.attr.summary.table <- NULL
  for (i in seq_len(n.sample)) {
    m <- rbind(post.attr.summary.list[[i]]$obs, post.attr.summary.list[[i]]$attr$uni.attr)
    m <- cbind(rep(i, dim(m)[1]), m, c(0, post.attr.summary.list[[i]]$attr$p.attr))
    post.attr.summary.table <- rbind(post.attr.summary.table, m)
    colnames(post.attr.summary.table) <- c("index", RowNames, "PostProb")
  }
  post.attr.summary.table
}

tnetfit <- function(steadyStateObj, perturbationObj, params = ternaryFitParameters(), xSeed = NA) {
  if (!identical(rownames(steadyStateObj), rownames(perturbationObj))) stop("steadyStateObj and perturbationObj must have identical rownames")
  if (!identical(colnames(steadyStateObj), colnames(perturbationObj))) stop("steadyStateObj and perturbationObj must have identical colnames")

  if (is.null(rownames(steadyStateObj))) gNames <- paste("Gene", seq_len(nrow(steadyStateObj)), sep = "") else gNames <- rownames(steadyStateObj)
  if (is.null(colnames(steadyStateObj))) expNames <- paste("Exp", seq_len(ncol(steadyStateObj)), sep = "") else expNames <- colnames(steadyStateObj)

  nGene <- as.integer(nrow(steadyStateObj))
  nExperiment <- as.integer(ncol(steadyStateObj))

  ssObj <- as.vector(t(steadyStateObj)) + 2
  pObj <- as.integer(t(perturbationObj) + 2)

  if (is.na(xSeed)) xSeed <- as.integer(floor(runif(1) * 10000))
  ### set.seed(xSeed) # removed to make BiocCheck happy - HAS 4/12/2021

  tmp <- .Call("tnetfit", as.integer(perturbationType(params)), as.integer(scoreType(params)), as.integer(backupStage(params)), as.integer(maxStage(params)), as.integer(maxTransition(params)), epsilon(params), as.integer(beta0(params)), chi0(params), delta(params), as.integer(ne(params)), as.integer(m0(params)), as.integer(maxDegree(params)), pAddParent(params), pExchangeParent(params), as.integer(neighborDegree(params)), pNeighborhood(params), rho(params), nGene, nExperiment, edgePenalty(params), ssObj, pObj)

  traces <- data.frame(muTrace = tmp$muTrace, sigmaTrace = tmp$sigmaTrace, sigmaRhoTrace = tmp$sigmaRhoTrace, temperatureTrace = tmp$temperatureTrace)

  ternaryFit(perturbationObj = perturbationObj, steadyStateObj = steadyStateObj, geneNames = gNames, experimentNames = expNames, degreeObjMin = tmp$degreeObjMin, graphObjMin = matrix(tmp$graphObjMin, nrow = nGene), tableObjMin = matrix(tmp$tableObjMin, ncol = nGene), newScore = tmp$newScore, minScore = tmp$minScore, finalTemperature = tmp$scTemperature, traces = traces, stageCount = tmp$stageCount, xSeed = as.integer(xSeed), inputParams = params)
}

ternaryFit <- function(perturbationObj, steadyStateObj, geneNames, experimentNames, degreeObjMin, graphObjMin, tableObjMin, newScore, minScore, finalTemperature, traces, stageCount, xSeed, inputParams) {
  new("ternaryFit", perturbationObj = perturbationObj, steadyStateObj = steadyStateObj, geneNames = geneNames, experimentNames = experimentNames, degreeObjMin = degreeObjMin, graphObjMin = graphObjMin, tableObjMin = tableObjMin, newScore = newScore, minScore = minScore, finalTemperature = finalTemperature, traces = traces, stageCount = stageCount, xSeed = xSeed, inputParams = inputParams)
}

## dim method
setMethod("dim", "ternaryFit", function(x) dim(x@perturbationObj))

## slot getters
setMethod("perturbationObj", "ternaryFit", function(x) x@perturbationObj)
setMethod("steadyStateObj", "ternaryFit", function(x) x@steadyStateObj)
setMethod("geneNames", "ternaryFit", function(x) x@geneNames)
setMethod("experimentNames", "ternaryFit", function(x) x@experimentNames)
setMethod("degreeObjMin", "ternaryFit", function(x) x@degreeObjMin)
setMethod("graphObjMin", "ternaryFit", function(x) x@graphObjMin)
setMethod("tableObjMin", "ternaryFit", function(x) x@tableObjMin)
setMethod("newScore", "ternaryFit", function(x) x@newScore)
setMethod("minScore", "ternaryFit", function(x) x@minScore)
setMethod("finalTemperature", "ternaryFit", function(x) x@finalTemperature)
setMethod("xSeed", "ternaryFit", function(x) x@xSeed)
setMethod("inputParams", "ternaryFit", function(x) x@inputParams)
setMethod("traces", "ternaryFit", function(x) x@traces)
setMethod("stageCount", "ternaryFit", function(x) x@stageCount)

## show method
setMethod("show", "ternaryFit", function(object) {
  cat(class(object), "instance with", dim(object)[2], "perturbation experiments, measuring", dim(object)[2], "genes \n")
  cat("Gene names:", geneNames(object), "\n")
  cat("Experiment names:", experimentNames(object), "\n")
})

## validity method
setValidity("ternaryFit", function(object) {
  nGene <- nrow(perturbationObj(object))
  nExperiment <- ncol(perturbationObj(object))

  if (nrow(steadyStateObj(object)) != nGene || ncol(steadyStateObj(object)) != nExperiment) {
    return("'steadyStateObj' slot and 'pertubationObj' slot must have the same dimensions")
  }
  indp <- which(perturbationObj(object) != 0, arr.ind = TRUE)
  if (any(steadyStateObj(object)[indp] != perturbationObj(object)[indp])) {
    return("Non-zero elements of 'perturbationObj' slot must match corresponding elements of 'steadyStateObj'")
  }
  if (length(degreeObjMin(object)) != nGene) {
    return("'degreeObjMin' slot must have length equal to the number of rows of the 'perturbationObj' slot")
  }
  if (nrow(graphObjMin(object)) != nGene || ncol(graphObjMin(object)) != nGene) {
    return("'graphObjMin' slot must be a matrix with row and column lengths equal to the number of rows of the 'perturbationObj' slot")
  }
  if (ncol(tableObjMin(object)) != nGene) {
    return("'tableObjMin' slot must be a matrix with row length equal to the number of rows of the 'perturbationObj' slot")
  }
  if (!is.numeric(newScore(object)) || length(newScore(object)) != 1 || is.na(newScore(object))) {
    return("'newScore' slot must be a single numeric")
  }
  if (!is.numeric(minScore(object)) || length(minScore(object)) != 1 || is.na(minScore(object))) {
    return("'minScore' slot must be a single numeric")
  }
  if (!is.numeric(finalTemperature(object)) || length(finalTemperature(object)) != 1 || is.na(finalTemperature(object))) {
    return("'finalTemperature' slot must be a single numeric")
  }
  if (!is.integer(xSeed(object)) || length(xSeed(object)) != 1 || is.na(xSeed(object))) {
    return("'xSeed' slot must be a single integer")
  }
  if (!is(inputParams(object), "ternaryFitParameters")) {
    return("'inputParams' slot must be an object of class 'ternaryFitParameters")
  }
  TRUE
})

## slot setters
setReplaceMethod("perturbationObj", "ternaryFit", function(x, value) {
  x@perturbationObj <- value
  validObject(x)
  x
})
setReplaceMethod("steadyStateObj", "ternaryFit", function(x, value) {
  x@steadyStateObj <- value
  validObject(x)
  x
})
setReplaceMethod("geneNames", "ternaryFit", function(x, value) {
  x@geneNames <- value
  validObject(x)
  x
})
setReplaceMethod("experimentNames", "ternaryFit", function(x, value) {
  x@experimentNames <- value
  validObject(x)
  x
})
setReplaceMethod("degreeObjMin", "ternaryFit", function(x, value) {
  x@degreeObjMin <- value
  validObject(x)
  x
})
setReplaceMethod("graphObjMin", "ternaryFit", function(x, value) {
  x@graphObjMin <- value
  validObject(x)
  x
})
setReplaceMethod("tableObjMin", "ternaryFit", function(x, value) {
  x@tableObjMin <- value
  validObject(x)
  x
})
setReplaceMethod("newScore", "ternaryFit", function(x, value) {
  x@newScore <- value
  validObject(x)
  x
})
setReplaceMethod("minScore", "ternaryFit", function(x, value) {
  x@minScore <- value
  validObject(x)
  x
})
setReplaceMethod("finalTemperature", "ternaryFit", function(x, value) {
  x@finalTemperature <- value
  validObject(x)
  x
})
setReplaceMethod("xSeed", "ternaryFit", function(x, value) {
  x@xSeed <- value
  validObject(x)
  x
})
setReplaceMethod("inputParams", "ternaryFit", function(x, value) {
  x@inputParams <- value
  validObject(x)
  x
})
setReplaceMethod("traces", "ternaryFit", function(x, value) {
  x@traces <- value
  validObject(x)
  x
})
setReplaceMethod("stageCount", "ternaryFit", function(x, value) {
  x@stageCount <- value
  validObject(x)
  x
})

predictAttractor <- function(tpost, perturbations, wildtype = TRUE, verbose = FALSE) {
  fg <- perturbations$perturbed.genes
  fs <- perturbations$forced.states + 2

  n.post <- dim(tableObjs(tpost))[3]
  n.gene <- dim(perturbationObj(tpost))[1]
  n.sample <- dim(perturbationObj(tpost))[2]

  attractor.list <- matrix(nrow = n.post, ncol = n.gene)
  for (i in seq_len(n.post)) {
    tn.model <- list(table = tableObjs(tpost)[, , i], graph = graphObjs(tpost)[, , i], degree = degreeObjs(tpost)[i, ])

    vec0 <- rep(2, length(tn.model$degree))
    vec0[fg] <- fs
    junk <- attractor.distance.summary(vec0, tn.model, wildtype, fg, fs)
    nc <- dim(junk$attractor)[2]
    attractor.list[i, ] <- summarize.attractor.2(junk$attractor[, 2:nc])
    if (verbose) if (i %% 1000 == 0) cat(paste(i, "/", n.post, "\n"))
  }

  tmp <- condense.attractor(attractor.list)
  return(list(post.prob = tmp$p.attr, attractor.summary = tmp$uni.attr))
}

getObservedAttractor <- function(perturbations, tableObj, graphObj, degreeObj, wildtype) {
  fg <- perturbations$perturbed.genes
  fs <- perturbations$forced.states + 2
  tn.model <- list(table = tableObj + 2, graph = graphObj, degree = degreeObj)
  vec0 <- rep(2, length(tn.model$degree))
  vec0[fg] <- fs
  junk <- attractor.distance.summary(vec0, tn.model, wildtype, fg, fs)
  nc <- dim(junk$attractor)[2]
  return(summarize.attractor.2(junk$attractor[, 2:nc]))
}

simulateSteadyState <- function(perturbationObj, tableObj, graphObj, degreeObj, wildtype = FALSE) {
  steadyStateObj <- matrix(nrow = nrow(perturbationObj), ncol = ncol(perturbationObj))
  for (k in seq_len(ncol(perturbationObj))) {
    ind <- which(perturbationObj[, k] != 0)
    perts <- list("perturbed.genes" = ind, "forced.states" = perturbationObj[ind, k])
    steadyStateObj[, k] <- getObservedAttractor(perts, tableObj, graphObj, degreeObj, wildtype)
  }
  return(steadyStateObj)
}

ternaryFitParameters <- function(perturbationType = as.integer(1),
                                 scoreType = as.integer(2),
                                 backupStage = as.integer(1),
                                 maxStage = as.integer(2000),
                                 maxTransition = as.integer(2000),
                                 epsilon = 1e-05,
                                 beta0 = as.integer(3),
                                 chi0 = 0.95,
                                 delta = 0.1,
                                 ne = as.integer(10000),
                                 m0 = as.integer(10000),
                                 maxDegree = as.integer(1),
                                 pAddParent = 0.1,
                                 pExchangeParent = 0.1,
                                 neighborDegree = as.integer(2),
                                 pNeighborhood = 0.01,
                                 rho = 0.25,
                                 edgePenalty = 0) {
  new("ternaryFitParameters", perturbationType = perturbationType, scoreType = scoreType, backupStage = backupStage, maxStage = maxStage, maxTransition = maxTransition, epsilon = epsilon, beta0 = beta0, chi0 = chi0, delta = delta, ne = ne, m0 = m0, maxDegree = maxDegree, pAddParent = pAddParent, pExchangeParent = pExchangeParent, neighborDegree = neighborDegree, pNeighborhood = pNeighborhood, rho = rho, edgePenalty = edgePenalty)
}

## slot getters
setMethod("perturbationType", "ternaryFitParameters", function(x) x@perturbationType)
setMethod("scoreType", "ternaryFitParameters", function(x) x@scoreType)
setMethod("backupStage", "ternaryFitParameters", function(x) x@backupStage)
setMethod("maxStage", "ternaryFitParameters", function(x) x@maxStage)
setMethod("maxTransition", "ternaryFitParameters", function(x) x@maxTransition)
setMethod("epsilon", "ternaryFitParameters", function(x) x@epsilon)
setMethod("beta0", "ternaryFitParameters", function(x) x@beta0)
setMethod("chi0", "ternaryFitParameters", function(x) x@chi0)
setMethod("delta", "ternaryFitParameters", function(x) x@delta)
setMethod("ne", "ternaryFitParameters", function(x) x@ne)
setMethod("m0", "ternaryFitParameters", function(x) x@m0)
setMethod("maxDegree", "ternaryFitParameters", function(x) x@maxDegree)
setMethod("pAddParent", "ternaryFitParameters", function(x) x@pAddParent)
setMethod("pExchangeParent", "ternaryFitParameters", function(x) x@pExchangeParent)
setMethod("neighborDegree", "ternaryFitParameters", function(x) x@neighborDegree)
setMethod("pNeighborhood", "ternaryFitParameters", function(x) x@pNeighborhood)
setMethod("rho", "ternaryFitParameters", function(x) x@rho)
setMethod("edgePenalty", "ternaryFitParameters", function(x) x@edgePenalty)

## show method
setMethod("show", "ternaryFitParameters", function(object) cat(class(object), "instance \n"))

## validity method
setValidity("ternaryFitParameters", function(object) {
  ints <- c(perturbationType(object), scoreType(object), backupStage(object), maxStage(object), maxTransition(object), beta0(object), ne(object), m0(object), maxDegree(object), neighborDegree(object))
  if (length(ints) != 10 || any(!is.integer(ints)) || any(is.na(ints))) {
    return("'perturbationType', 'scoreType', 'backupStage', 'maxStage', 'maxTransition', 'beta0', 'ne', 'm0', 'maxDegree', and 'neighborDegree' must all be single integers")
  }
  nums <- c(epsilon(object), chi0(object), delta(object), pAddParent(object), pExchangeParent(object), rho(object), edgePenalty(object))
  if (length(nums) != 7 || any(!is.numeric(nums)) || any(is.na(nums))) {
    return("'epsilon', 'chi0', 'delta', 'pAddParent', 'pExchangeParent', 'rho', and 'edgePenalty' must all be single numeric values")
  }
  TRUE
})

## slot setters
setReplaceMethod("perturbationType", "ternaryFitParameters", function(x, value) {
  x@perturbationType <- value
  validObject(x)
  x
})
setReplaceMethod("scoreType", "ternaryFitParameters", function(x, value) {
  x@scoreType <- value
  validObject(x)
  x
})
setReplaceMethod("backupStage", "ternaryFitParameters", function(x, value) {
  x@backupStage <- value
  validObject(x)
  x
})
setReplaceMethod("maxStage", "ternaryFitParameters", function(x, value) {
  x@maxStage <- value
  validObject(x)
  x
})
setReplaceMethod("maxTransition", "ternaryFitParameters", function(x, value) {
  x@maxTransition <- value
  validObject(x)
  x
})
setReplaceMethod("epsilon", "ternaryFitParameters", function(x, value) {
  x@epsilon <- value
  validObject(x)
  x
})
setReplaceMethod("beta0", "ternaryFitParameters", function(x, value) {
  x@beta0 <- value
  validObject(x)
  x
})
setReplaceMethod("chi0", "ternaryFitParameters", function(x, value) {
  x@chi0 <- value
  validObject(x)
  x
})
setReplaceMethod("delta", "ternaryFitParameters", function(x, value) {
  x@delta <- value
  validObject(x)
  x
})
setReplaceMethod("ne", "ternaryFitParameters", function(x, value) {
  x@ne <- value
  validObject(x)
  x
})
setReplaceMethod("m0", "ternaryFitParameters", function(x, value) {
  x@m0 <- value
  validObject(x)
  x
})
setReplaceMethod("maxDegree", "ternaryFitParameters", function(x, value) {
  x@maxDegree <- value
  validObject(x)
  x
})
setReplaceMethod("pAddParent", "ternaryFitParameters", function(x, value) {
  x@pAddParent <- value
  validObject(x)
  x
})
setReplaceMethod("pExchangeParent", "ternaryFitParameters", function(x, value) {
  x@pExchangeParent <- value
  validObject(x)
  x
})
setReplaceMethod("neighborDegree", "ternaryFitParameters", function(x, value) {
  x@neighborDegree <- value
  validObject(x)
  x
})
setReplaceMethod("pNeighborhood", "ternaryFitParameters", function(x, value) {
  x@pNeighborhood <- value
  validObject(x)
  x
})
setReplaceMethod("rho", "ternaryFitParameters", function(x, value) {
  x@rho <- value
  validObject(x)
  x
})
setReplaceMethod("edgePenalty", "ternaryFitParameters", function(x, value) {
  x@edgePenalty <- value
  validObject(x)
  x
})

setClass(
  "ternaryFitParameters",
  representation(
    perturbationType = "integer", # a single integer value
    scoreType = "integer", # a single integer value
    backupStage = "integer", # a single integer value
    maxStage = "integer", # a single integer value
    maxTransition = "integer", # a single integer value
    epsilon = "numeric", # a single numeric value
    beta0 = "integer", # a single integer value
    chi0 = "numeric", # a single numeric value
    delta = "numeric", # a single numeric value
    ne = "integer", # a single integer value
    m0 = "integer", # a single integer value
    maxDegree = "integer", # a single integer value
    pAddParent = "numeric", # a single numeric value
    pExchangeParent = "numeric", # a single numeric value
    neighborDegree = "integer", # a single integer value
    pNeighborhood = "numeric", # a numeric vector of length ??
    rho = "numeric", # a single numeric value
    edgePenalty = "numeric" # a single numeric value
  )
)

setClass(
  "ternaryFit",
  representation(
    perturbationObj = "matrix", # an nGene by nExperiment matrix
    steadyStateObj = "matrix", # an nGene by nExperiment matrix
    geneNames = "character", # a vector of gene names
    experimentNames = "character", # a vector of experiment names
    degreeObjMin = "integer", # an integer vector of length nGene
    graphObjMin = "matrix", # an nGene by nGene matrix
    tableObjMin = "matrix", # an nGene by tableWidth matrix
    newScore = "numeric", # a single numeric value
    minScore = "numeric", # a single numeric value
    finalTemperature = "numeric", # a single numeric value
    traces = "data.frame", # a data frame of the fit traces
    stageCount = "integer", # a single integer value
    xSeed = "integer", # a single integer value
    inputParams = "ternaryFitParameters"
    # class containing input parameters
  )
)

setClass(
  "ternaryPost",
  representation(
    perturbationObj = "matrix", # an nGene by nExperiment matrix
    steadyStateObj = "matrix", # an nGene by nExperiment matrix
    geneNames = "character", # a vector of gene names
    experimentNames = "character", # a vector of experiment names
    scores = "numeric", # numeric vector
    degreeObjs = "matrix", # integer matrix
    graphObjs = "array", # integer array
    tableObjs = "array", # integer array
    inputParams = "ternaryFitParameters"
    # class containing input parameters
  )
)

ternaryPost <- function(perturbationObj, steadyStateObj, geneNames, experimentNames, scores, degreeObjs, graphObjs, tableObjs, inputParams) {
  new("ternaryPost", perturbationObj = perturbationObj, steadyStateObj = steadyStateObj, geneNames = geneNames, experimentNames = experimentNames, scores = scores, degreeObjs = degreeObjs, graphObjs = graphObjs, tableObjs = tableObjs, inputParams = inputParams)
}

## dim method
setMethod("dim", "ternaryPost", function(x) dim(x@perturbationObj))

## slot getters
setMethod("perturbationObj", "ternaryPost", function(x) x@perturbationObj)
setMethod("steadyStateObj", "ternaryPost", function(x) x@steadyStateObj)
setMethod("geneNames", "ternaryPost", function(x) x@geneNames)
setMethod("experimentNames", "ternaryPost", function(x) x@experimentNames)
setMethod("scores", "ternaryPost", function(x) x@scores)
setMethod("degreeObjs", "ternaryPost", function(x) x@degreeObjs)
setMethod("graphObjs", "ternaryPost", function(x) x@graphObjs)
setMethod("tableObjs", "ternaryPost", function(x) x@tableObjs)
setMethod("inputParams", "ternaryPost", function(x) x@inputParams)

## show method
setMethod("show", "ternaryPost", function(object) {
  cat(class(object), "instance with", dim(object)[2], "perturbation experiments, measuring", dim(object)[2], "genes \n")
  cat("Gene names:", geneNames(object), "\n")
  cat("Experiment names:", experimentNames(object), "\n")
})

## validity method
setValidity("ternaryPost", function(object) {
  TRUE
})

## slot setters
setReplaceMethod("perturbationObj", "ternaryPost", function(x, value) {
  x@perturbationObj <- value
  validObject(x)
  x
})
setReplaceMethod("steadyStateObj", "ternaryPost", function(x, value) {
  x@steadyStateObj <- value
  validObject(x)
  x
})
setReplaceMethod("geneNames", "ternaryPost", function(x, value) {
  x@geneNames <- value
  validObject(x)
  x
})
setReplaceMethod("experimentNames", "ternaryPost", function(x, value) {
  x@experimentNames <- value
  validObject(x)
  x
})
setReplaceMethod("scores", "ternaryPost", function(x, value) {
  x@scores <- value
  validObject(x)
  x
})
setReplaceMethod("degreeObjs", "ternaryPost", function(x, value) {
  x@degreeObjs <- value
  validObject(x)
  x
})
setReplaceMethod("graphObjs", "ternaryPost", function(x, value) {
  x@graphObjs <- value
  validObject(x)
  x
})
setReplaceMethod("tableObjs", "ternaryPost", function(x, value) {
  x@tableObjs <- value
  validObject(x)
  x
})
setReplaceMethod("inputParams", "ternaryPost", function(x, value) {
  x@inputParams <- value
  validObject(x)
  x
})

tnetpost <- function(tfit, mdelta = as.integer(10000), msample = as.integer(2000), temperatureScale = 1.0, xSeed = NA) {
  ssObj <- as.vector(t(steadyStateObj(tfit)) + 2)
  pObj <- as.integer(t(perturbationObj(tfit)) + 2)

  nGene <- as.integer(nrow(steadyStateObj(tfit)))
  nExperiment <- as.integer(ncol(steadyStateObj(tfit)))

  if (is.na(xSeed)) xSeed <- as.integer(floor(runif(1) * 10000))
  ### set.seed(xSeed) # removed to make BiocCheck happy - HAS 4/12/2021

  inputParams <- inputParams(tfit)

  obj <- .Call("tnetpost", msample, mdelta, temperatureScale, xSeed(tfit), scoreType(inputParams), perturbationType(inputParams), backupStage(inputParams), maxStage(inputParams), maxTransition(inputParams), epsilon(inputParams), beta0(inputParams), chi0(inputParams), delta(inputParams), rho(inputParams), ne(inputParams), maxDegree(inputParams), pAddParent(inputParams), pExchangeParent(inputParams), neighborDegree(inputParams), pNeighborhood(inputParams), nGene, nExperiment, edgePenalty(inputParams), m0(inputParams), ssObj, pObj, newScore(tfit), minScore(tfit), degreeObjMin(tfit), graphObjMin(tfit), tableObjMin(tfit), finalTemperature(tfit))

  ternaryPost(perturbationObj = perturbationObj(tfit), steadyStateObj = steadyStateObj(tfit), geneNames = geneNames(tfit), experimentNames = experimentNames(tfit), scores = obj$scores, degreeObjs = matrix(obj$degreeObjs, nrow = length(obj$scores), byrow = TRUE), graphObjs = array(obj$graphObjs, dim = c(nGene, nGene, length(obj$scores))), tableObjs = array(obj$tableObjs, dim = c(length(obj$tableObjs) / (nGene * length(obj$scores)), nGene, length(obj$scores))), inputParams = inputParams)
}

plotFit <- function(ternaryFit, type = "interactive", ...) {
  grph <- graphObjMin(ternaryFit)
  deg <- apply(grph, 2, function(x) sum(x > 0))
  el <- cbind(as.vector(grph)[as.vector(grph) > 0], rep(1:ncol(grph), deg))
  el2 <- cbind(geneNames(ternaryFit)[el[, 1]], geneNames(ternaryFit)[el[, 2]])
  if (type == "static") plot(graph.edgelist(el2), ...)
  if (type == "interactive") tkplot(graph.edgelist(el2), ...)
}

callNetworkMonteCarloRwrap <- function(i, n,
    n_node, i_exp, i_node, outcome, value,
    is_perturbation, max_parents, n_cycles,
    n_write, T_lo, T_hi, target_score,
    logfile, n_thread, init_parents, init_outcomes,
    exchange_interval, adjust_move_size_interval,
    max_states, callback)
{

    if (is.function(callback)) 
        callback(i)

    results <- .Call("network_monte_carlo_Rwrap",
        n, n_node, i_exp, i_node, outcome, value,
        is_perturbation, max_parents, n_cycles,
        n_write, T_lo, T_hi, target_score,
        logfile, n_thread, init_parents, init_outcomes,
        exchange_interval, adjust_move_size_interval,
        max_states)

    names(results) <- c("unnormalized_score",
        "normalized_score",
        "parents",
        "outcomes",
        "trajectories")

    dim(results$parents) <- c(n_node, max_parents)
    dim(results$outcomes) <- c(n_node, rep(3,max_parents))

    results
}

parallelFitCheckArgs <- function(i_exp, i_node, outcome, value,
    is_perturbation, T_lo, T_hi, max_parents, exchange_interval,
    adjust_move_size_interval, init_parents,
    init_outcomes, n_thread, n_node, max_nodes,
    max_states, callback)
{
    stopifnot(is.integer(i_exp))
    stopifnot(is.integer(i_node))
    stopifnot(is.integer(outcome))
    stopifnot(is.numeric(value))
    stopifnot(is.integer(is_perturbation))
    stopifnot(T_lo > 0)
    stopifnot(T_hi >= T_lo)
    stopifnot(max_parents >= 1)
    stopifnot(exchange_interval >= 1)
    stopifnot(adjust_move_size_interval >= 1)
    stopifnot(max_states >= 1)
    stopifnot(is.null(init_parents) || is.integer(init_parents));
    stopifnot(is.null(init_outcomes) || is.integer(init_outcomes));
    stopifnot(n_thread >= 1)
    stopifnot(n_node <= max_nodes)
    stopifnot(is.null(callback) || is.function(callback));
}

parallelFit <- function(experiment_set,
    max_parents, n_cycles, n_write, T_lo, T_hi, target_score,
    n_proc, logfile, n_thread=1, init_parents=NULL, init_outcomes=NULL,
    exchange_interval=1000, adjust_move_size_interval=7001,
    max_states=10, callback=NULL)
{
    i_exp <- experiment_set$i_exp
    i_node <- experiment_set$i_node
    outcome <- experiment_set$outcome
    value <- experiment_set$value
    is_perturbation <- experiment_set$is_perturbation
    if (is.logical(is_perturbation)) 
        is_perturbation <- as.integer(is_perturbation)
    n <- nrow(experiment_set)
    n_node <- max(i_node)+1
    max_nodes = .Call("max_nodes_Rwrap")
    parallelFitCheckArgs(i_exp, i_node, outcome, value,
        is_perturbation, T_lo, T_hi, max_parents, exchange_interval,
        adjust_move_size_interval, init_parents,
        init_outcomes, n_thread, n_node, max_nodes,
        max_states, callback)
    if (.Call("is_MPI_available") &&
        requireNamespace("BiocParallel") && 
        requireNamespace("Rmpi") && 
        requireNamespace("snow")) {
        using_MPI = TRUE
        bp_param <- BiocParallel::SnowParam(n_proc, type="MPI")
    } else {
        if (n_proc > 1) stop("Rmpi not available, but n_proc > 1")
        using_MPI = FALSE   
        bp_param <- BiocParallel::SerialParam()
    }
    results <- BiocParallel::bplapply(seq_len(n_proc), 
        callNetworkMonteCarloRwrap, BPPARAM=bp_param,
        n, n_node, i_exp, i_node, outcome, value,
        is_perturbation, max_parents, n_cycles, n_write,
        T_lo, T_hi, target_score, logfile, n_thread,
        init_parents, init_outcomes, exchange_interval,
        adjust_move_size_interval, max_states, callback)
    if (using_MPI) {
        Rmpi::mpi.comm.disconnect()
        Rmpi::mpi.finalize()
    }
    results
}

########## for R library

####################################################################

read.cc.app <- function(fname) {
  junk <- scan(fname, nlines = 5, what = "character", sep = "\n")

  StartDate <- junk[1]
  EndDate <- junk[2]
  InputFile <- junk[3]
  OutputFile <- junk[4]
  Memo <- junk[5]

  junk <- scan(fname, skip = 5)

  PerturbType <- junk[1]
  ScoreType <- junk[2]
  nBackupStage <- junk[3]
  MaxStage <- junk[4]
  MaxTransition <- junk[5]
  epsilon <- junk[6]
  beta <- junk[7]
  chi0 <- junk[8]
  delta <- junk[9]
  ne <- junk[10]
  m0 <- junk[11]
  MaxDegree <- junk[12]
  PAddParent <- junk[13]
  PExchangeParent <- junk[14]
  NeighborDegree <- junk[15]
  icount <- 15
  pNeighborhood <- NULL
  if (NeighborDegree > 1) {
    for (i in seq_len((NeighborDegree - 1))) {
      icount <- icount + 1
      pNeighborhood <- c(pNeighborhood, junk[icount])
    }
  }
  icount <- icount + 1
  rho <- junk[icount]
  icount <- icount + 1
  xSeed <- junk[icount]
  icount <- icount + 1
  nGene <- junk[icount]
  icount <- icount + 1
  nExp <- junk[icount]
  icount <- icount + 1
  edgePenalty <- junk[icount]

  DataResponse <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)
  DataPerturbation <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)

  icount <- icount + 1
  NewScore <- junk[icount]
  icount <- icount + 1
  MinScore <- junk[icount]

  Fit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (Fit.InDegree[j] > 0) {
      incr <- Fit.InDegree[j]
      net.graph <- append(net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (Fit.InDegree[j] == 0) {
      net.graph <- append(net.graph, list(NULL))
    }
  }
  net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 3^Fit.InDegree[j]
    net.op <- append(net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }
  net.table <- NULL

  MinFit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  min.net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (MinFit.InDegree[j] > 0) {
      incr <- MinFit.InDegree[j]
      min.net.graph <- append(min.net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (MinFit.InDegree[j] == 0) {
      min.net.graph <- append(min.net.graph, list(NULL))
    }
  }
  min.net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 3^MinFit.InDegree[j]
    min.net.op <- append(min.net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }


  icount <- icount + 1
  FinalTemperature <- junk[icount]
  icount <- icount + 1
  nStage <- junk[icount]

  MuTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaRhoTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  TemperatureTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  AcceptanceTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage

  fit.obj <- list(
    xSeed = xSeed,
    nStage = nStage,
    PerturbType = PerturbType,
    ScoreType = ScoreType,
    nBackupStage = nBackupStage,
    nExp = nExp,
    nGene = nGene,
    edgePenalty = edgePenalty,
    MaxStage = MaxStage,
    MaxTransition = MaxTransition,
    epsilon = epsilon,
    beta = beta,
    chi0 = chi0,
    delta = delta,
    ne = ne,
    m0 = m0,
    m1 = NULL,
    m2 = NULL,
    MaxDegree = MaxDegree,
    PAddParent = PAddParent,
    PExchangeParent = PExchangeParent,
    NeighborDegree = NeighborDegree,
    pNeighborhood = pNeighborhood,
    rho = rho,
    FinalTemperature = FinalTemperature,
    NewScore = NewScore,
    MinScore = MinScore,
    MinStage = NULL,
    MinTransition = NULL,
    MinFit.InDegree = MinFit.InDegree,
    Fit.InDegree = Fit.InDegree,
    min.net.graph = min.net.graph,
    min.net.op = min.net.op,
    net.graph = net.graph,
    net.op = net.op,
    MuTrace = MuTrace,
    SigmaTrace = SigmaTrace,
    SigmaRhoTrace = SigmaRhoTrace,
    TemperatureTrace = TemperatureTrace,
    AcceptanceTrace = AcceptanceTrace,
    DataResponse = DataResponse,
    DataPerturbation = DataPerturbation,
    Memo = Memo,
    StartDate = StartDate,
    EndDate = EndDate,
    InputFile = InputFile,
    OutputFile = OutputFile
  )

  return(fit.obj)
}

###################################################


read.cc.app.table.version <- function(fname) {
  junk <- scan(fname, nlines = 5, what = "character", sep = "\n")

  StartDate <- junk[1]
  EndDate <- junk[2]
  InputFile <- junk[3]
  OutputFile <- junk[4]
  Memo <- junk[5]

  junk <- scan(fname, skip = 5)

  PerturbType <- junk[1]
  ScoreType <- junk[2]
  nBackupStage <- junk[3]
  MaxStage <- junk[4]
  MaxTransition <- junk[5]
  epsilon <- junk[6]
  beta <- junk[7]
  chi0 <- junk[8]
  delta <- junk[9]
  ne <- junk[10]
  m0 <- junk[11]
  MaxDegree <- junk[12]
  PAddParent <- junk[13]
  PRemoveParent <- junk[14]
  PExchangeParent <- junk[15]
  NeighborDegree <- junk[16]
  icount <- 16
  pNeighborhood <- NULL
  if (NeighborDegree > 1) {
    for (i in seq_len((NeighborDegree - 1))) {
      icount <- icount + 1
      pNeighborhood <- c(pNeighborhood, junk[icount])
    }
  }
  icount <- icount + 1
  rho <- junk[icount]
  icount <- icount + 1
  xSeed <- junk[icount]
  icount <- icount + 1
  nGene <- junk[icount]
  icount <- icount + 1
  nExp <- junk[icount]
  icount <- icount + 1
  edgePenalty <- junk[icount]

  DataResponse <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)
  DataPerturbation <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)

  icount <- icount + 1
  NewScore <- junk[icount]
  icount <- icount + 1
  MinScore <- junk[icount]

  Fit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (Fit.InDegree[j] > 0) {
      incr <- Fit.InDegree[j]
      net.graph <- append(net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (Fit.InDegree[j] == 0) {
      net.graph <- append(net.graph, list(NULL))
    }
  }
  net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 3^Fit.InDegree[j]
    net.op <- append(net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }
  net.table <- NULL

  MinFit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  min.net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (MinFit.InDegree[j] > 0) {
      incr <- MinFit.InDegree[j]
      min.net.graph <- append(min.net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (MinFit.InDegree[j] == 0) {
      min.net.graph <- append(min.net.graph, list(NULL))
    }
  }
  min.net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 3^MinFit.InDegree[j]
    min.net.op <- append(min.net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }


  icount <- icount + 1
  FinalTemperature <- junk[icount]
  icount <- icount + 1
  nStage <- junk[icount]

  MuTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaRhoTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  TemperatureTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage

  fit.obj <- list(
    xSeed = xSeed,
    nStage = nStage,
    PerturbType = PerturbType,
    ScoreType = ScoreType,
    nBackupStage = nBackupStage,
    nExp = nExp,
    nGene = nGene,
    edgePenalty = edgePenalty,
    MaxStage = MaxStage,
    MaxTransition = MaxTransition,
    epsilon = epsilon,
    beta = beta,
    chi0 = chi0,
    delta = delta,
    ne = ne,
    m0 = m0,
    m1 = NULL,
    m2 = NULL,
    MaxDegree = MaxDegree,
    PAddParent = PAddParent,
    PRemoveParent = PRemoveParent,
    PExchangeParent = PExchangeParent,
    NeighborDegree = NeighborDegree,
    pNeighborhood = pNeighborhood,
    rho = rho,
    FinalTemperature = FinalTemperature,
    NewScore = NewScore,
    MinScore = MinScore,
    MinStage = NULL,
    MinTransition = NULL,
    MinFit.InDegree = MinFit.InDegree,
    Fit.InDegree = Fit.InDegree,
    min.net.graph = min.net.graph,
    min.net.op = min.net.op,
    net.graph = net.graph,
    net.op = net.op,
    MuTrace = MuTrace,
    SigmaTrace = SigmaTrace,
    SigmaRhoTrace = SigmaRhoTrace,
    TemperatureTrace = TemperatureTrace,
    AcceptanceTrace = NULL,
    DataResponse = DataResponse,
    DataPerturbation = DataPerturbation,
    Memo = Memo,
    StartDate = StartDate,
    EndDate = EndDate,
    InputFile = InputFile,
    OutputFile = OutputFile
  )

  return(fit.obj)
}



###################################################

read.cc.app.bool <- function(fname) {
  junk <- scan(fname, nlines = 5, what = "character", sep = "\n")

  StartDate <- junk[1]
  EndDate <- junk[2]
  InputFile <- junk[3]
  OutputFile <- junk[4]
  Memo <- junk[5]

  junk <- scan(fname, skip = 5)

  PerturbType <- junk[1]
  ScoreType <- junk[2]
  nBackupStage <- junk[3]
  MaxStage <- junk[4]
  MaxTransition <- junk[5]
  epsilon <- junk[6]
  beta <- junk[7]
  chi0 <- junk[8]
  delta <- junk[9]
  ne <- junk[10]
  m0 <- junk[11]
  MaxDegree <- junk[12]
  PAddParent <- junk[13]
  PExchangeParent <- junk[14]
  NeighborDegree <- junk[15]
  icount <- 15
  pNeighborhood <- NULL
  if (NeighborDegree > 1) {
    for (i in seq_len((NeighborDegree - 1))) {
      icount <- icount + 1
      pNeighborhood <- c(pNeighborhood, junk[icount])
    }
  }
  icount <- icount + 1
  rho <- junk[icount]
  icount <- icount + 1
  xSeed <- junk[icount]
  icount <- icount + 1
  nGene <- junk[icount]
  icount <- icount + 1
  nExp <- junk[icount]
  icount <- icount + 1
  edgePenalty <- junk[icount]
  icount <- icount + 1
  cyclePenaltyN <- junk[icount]
  cyclePenaltyKnots <- junk[icount + c(1:(2 * cyclePenaltyN + 2))]
  icount <- icount + (2 * cyclePenaltyN + 2)

  DataResponse <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)
  DataPerturbation <- matrix(junk[c(1:(nGene * nExp)) + icount], nGene, nExp, byrow = TRUE)
  icount <- icount + (nGene * nExp)

  icount <- icount + 1
  NewScore <- junk[icount]
  icount <- icount + 1
  MinScore <- junk[icount]

  Fit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (Fit.InDegree[j] > 0) {
      incr <- Fit.InDegree[j]
      net.graph <- append(net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (Fit.InDegree[j] == 0) {
      net.graph <- append(net.graph, list(NULL))
    }
  }
  net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 2^Fit.InDegree[j]
    net.op <- append(net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }
  net.table <- NULL

  MinFit.InDegree <- junk[(1:nGene) + icount]
  icount <- icount + nGene
  min.net.graph <- NULL
  for (j in seq_len(nGene)) {
    if (MinFit.InDegree[j] > 0) {
      incr <- MinFit.InDegree[j]
      min.net.graph <- append(min.net.graph, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    if (MinFit.InDegree[j] == 0) {
      min.net.graph <- append(min.net.graph, list(NULL))
    }
  }
  min.net.op <- NULL
  for (j in seq_len(nGene)) {
    incr <- 2^MinFit.InDegree[j]
    min.net.op <- append(min.net.op, list(junk[c(1:incr) + icount]))
    icount <- icount + incr
  }


  icount <- icount + 1
  FinalTemperature <- junk[icount]
  icount <- icount + 1
  nStage <- junk[icount]

  MuTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  SigmaRhoTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage
  TemperatureTrace <- junk[c(1:nStage) + icount]
  icount <- icount + nStage

  fit.obj <- list(
    xSeed = xSeed,
    nStage = nStage,
    PerturbType = PerturbType,
    ScoreType = ScoreType,
    nBackupStage = nBackupStage,
    nExp = nExp,
    nGene = nGene,
    edgePenalty = edgePenalty,
    cyclePenaltyN = cyclePenaltyN,
    cyclePenaltyKnots = cyclePenaltyKnots,
    MaxStage = MaxStage,
    MaxTransition = MaxTransition,
    epsilon = epsilon,
    beta = beta,
    chi0 = chi0,
    delta = delta,
    ne = ne,
    m0 = m0,
    m1 = NULL,
    m2 = NULL,
    MaxDegree = MaxDegree,
    PAddParent = PAddParent,
    PExchangeParent = PExchangeParent,
    NeighborDegree = NeighborDegree,
    pNeighborhood = pNeighborhood,
    rho = rho,
    FinalTemperature = FinalTemperature,
    NewScore = NewScore,
    MinScore = MinScore,
    MinStage = NULL,
    MinTransition = NULL,
    MinFit.InDegree = MinFit.InDegree,
    Fit.InDegree = Fit.InDegree,
    min.net.graph = min.net.graph,
    min.net.op = min.net.op,
    net.graph = net.graph,
    net.op = net.op,
    MuTrace = MuTrace,
    SigmaTrace = SigmaTrace,
    SigmaRhoTrace = SigmaRhoTrace,
    TemperatureTrace = TemperatureTrace,
    AcceptanceTrace = NULL,
    DataResponse = DataResponse,
    DataPerturbation = DataPerturbation,
    Memo = Memo,
    StartDate = StartDate,
    EndDate = EndDate,
    InputFile = InputFile,
    OutputFile = OutputFile
  )

  return(fit.obj)
}



########################################################

read.cc.app.posterior <- function(fname) {
  junk <- scan(fname, nlines = 5, what = "character", sep = "\n")

  StartDate <- junk[1]
  EndDate <- junk[2]
  FitFile <- junk[3]
  OutputPosteriorFile <- junk[4]
  OutputPosteriorMemo <- junk[5]

  junk <- scan(fname, skip = 5)

  m0 <- junk[1]
  mdelta <- junk[2]
  parameter <- junk[3]
  xSeed <- junk[4]
  FinalTemperature <- junk[5]
  nGene <- junk[6]
  icount <- 6

  fit.score <- rep(NA, m0)
  fit.indegree.list <- NULL
  for (i in seq_len(m0)) {
    fit.indegree.list <- append(fit.indegree.list, list(NULL))
  }
  fit.graph.list <- fit.indegree.list
  fit.op.list <- fit.indegree.list

  for (iii in seq_len(m0)) {
    icount <- icount + 1
    fit.score[iii] <- junk[icount]

    fit.indegree.list[[iii]] <- junk[(1:nGene) + icount]
    icount <- icount + nGene

    fit.graph <- NULL
    for (j in seq_len(nGene)) {
      if (fit.indegree.list[[iii]][j] > 0) {
        incr <- fit.indegree.list[[iii]][j]
        fit.graph <- append(fit.graph, list(junk[c(1:incr) + icount]))
        icount <- icount + incr
      }
      if (fit.indegree.list[[iii]][j] == 0) {
        fit.graph <- append(fit.graph, list(NULL))
      }
    }
    fit.graph.list[[iii]] <- fit.graph
    fit.op <- NULL
    for (j in seq_len(nGene)) {
      incr <- 3^fit.indegree.list[[iii]][j]
      fit.op <- append(fit.op, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    fit.op.list[[iii]] <- fit.op
  }

  posterior.obj <- list(
    StartDate = StartDate,
    EndDate = EndDate,
    FitFile = FitFile,
    OutputPosteriorFile = OutputPosteriorFile,
    OutputPosteriorMemo = OutputPosteriorMemo,
    m0 = m0,
    mdelta = mdelta,
    parameter = parameter,
    xSeed = xSeed,
    FinalTemperature = FinalTemperature,
    nGene = nGene,
    fit.score = fit.score,
    fit.indegree.list = fit.indegree.list,
    fit.graph.list = fit.graph.list,
    fit.op.list = fit.op.list
  )

  return(posterior.obj)
}

########################################################

read.cc.app.posterior.bool <- function(fname) {
  junk <- scan(fname, nlines = 5, what = "character", sep = "\n")

  StartDate <- junk[1]
  EndDate <- junk[2]
  FitFile <- junk[3]
  OutputPosteriorFile <- junk[4]
  OutputPosteriorMemo <- junk[5]

  junk <- scan(fname, skip = 5)

  m0 <- junk[1]
  mdelta <- junk[2]
  parameter <- junk[3]
  xSeed <- junk[4]
  FinalTemperature <- junk[5]
  nGene <- junk[6]
  icount <- 6

  fit.score <- rep(NA, m0)
  fit.indegree.list <- NULL
  for (i in seq_len(m0)) {
    fit.indegree.list <- append(fit.indegree.list, list(NULL))
  }
  fit.graph.list <- fit.indegree.list
  fit.op.list <- fit.indegree.list

  for (iii in seq_len(m0)) {
    icount <- icount + 1
    fit.score[iii] <- junk[icount]

    fit.indegree.list[[iii]] <- junk[(1:nGene) + icount]
    icount <- icount + nGene

    fit.graph <- NULL
    for (j in seq_len(nGene)) {
      if (fit.indegree.list[[iii]][j] > 0) {
        incr <- fit.indegree.list[[iii]][j]
        fit.graph <- append(fit.graph, list(junk[c(1:incr) + icount]))
        icount <- icount + incr
      }
      if (fit.indegree.list[[iii]][j] == 0) {
        fit.graph <- append(fit.graph, list(NULL))
      }
    }
    fit.graph.list[[iii]] <- fit.graph
    fit.op <- NULL
    for (j in seq_len(nGene)) {
      incr <- 2^fit.indegree.list[[iii]][j]
      fit.op <- append(fit.op, list(junk[c(1:incr) + icount]))
      icount <- icount + incr
    }
    fit.op.list[[iii]] <- fit.op
  }

  posterior.obj <- list(
    StartDate = StartDate,
    EndDate = EndDate,
    FitFile = FitFile,
    OutputPosteriorFile = OutputPosteriorFile,
    OutputPosteriorMemo = OutputPosteriorMemo,
    m0 = m0,
    mdelta = mdelta,
    parameter = parameter,
    xSeed = xSeed,
    FinalTemperature = FinalTemperature,
    nGene = nGene,
    fit.score = fit.score,
    fit.indegree.list = fit.indegree.list,
    fit.graph.list = fit.graph.list,
    fit.op.list = fit.op.list
  )

  return(posterior.obj)
}

####################################################################

ArrayToHash <- function(pIA, nOutcomes = 3) {
  n <- length(pIA)
  tempi <- 0

  for (i in seq_len(n)) {
    tempi <- tempi + (nOutcomes^(i - 1)) * (pIA[i] - 1)
  }

  tempi <- tempi + 1

  return(tempi)
}

############################################################

f4p <- function(x) {
  sum(4^x)
}

############################################################

condense.attractor <- function(m, thr = 0) {
  nr <- dim(m)[1]
  nc <- dim(m)[2]
  mm <- m


  for (i in seq_len(nc)) {
    mm[, i][m[, i] == 9] <- 2
  }
  mm <- mm + 1
  code <- apply(mm, 1, f4p)

  unicode <- unique(code)

  p.attr <- rep(0, length(unicode))
  uni.attr <- matrix(0, length(unicode), nc)

  for (i in seq_len(length(unicode))) {
    p.attr[i] <- mean(code == unicode[i])
    ind <- min(c(1:nr)[code == unicode[i]])
    uni.attr[i, ] <- m[ind, ]
  }

  ind <- rev(sort.list(p.attr))
  uni.attr <- as.matrix(uni.attr[ind, ])
  p.attr <- p.attr[ind]
  uni.attr <- uni.attr[p.attr >= thr, ]
  p.attr <- p.attr[p.attr >= thr]


  return(list(p.attr = p.attr, uni.attr = uni.attr))
}

############################################################

summarize.attractor.calc <- function(m01) {
  m0 <- m01[1]
  m1 <- m01[2]

  ans <- 0
  if ((m0 == -1) & (m1 <= 0)) {
    ans <- -1
  }
  if ((m0 == -1) & (m1 == 1)) {
    ans <- 9
  }
  if ((m0 >= 0) & (m1 == 1)) {
    ans <- 1
  }

  return(ans)
}

############################################################


summarize.attractor.1 <- function(m) {
  m <- as.matrix(m)
  attractor <- apply(m, 1, mean)
  return(attractor)
}

############################################################


summarize.attractor.2 <- function(m) {
  m <- as.matrix(m)
  m0 <- apply(m, 1, min)
  m1 <- apply(m, 1, max)
  attractor <- apply(cbind(m0, m1), 1, summarize.attractor.calc)
  return(attractor)
}


############################################################



summarize.attractor.bool <- function(m) {
  m <- as.matrix(m)
  m0 <- apply(m, 1, min)
  m1 <- apply(m, 1, max)
  attractor <- 1 * (m0 == 1 & m1 == 1) + 9 * (m0 < m1)
  return(attractor)
}


############################################################


score.attractor <- function(x) {
  obs <- x[1]
  mn <- x[2]
  mx <- x[3]

  ans <- 1
  if ((obs == 1) & (mn == 1) & (mx <= 2)) {
    ans <- 0
  }
  if ((obs == 2) & (mn == 2) & (mx == 2)) {
    ans <- 0
  }
  if ((obs == 3) & (mn >= 2) & (mx == 3)) {
    ans <- 0
  }

  return(ans)
}


############################################################

apply.op <- function(vec, tn.model) {
  n <- length(vec)
  new.vec <- vec
  for (i in seq_len(n)) {
    if (tn.model$degree[i] == 0) {
      new.vec[i] <- 2
    }
    if (tn.model$degree[i] > 0) {
      in.state <- vec[tn.model$graph[1:tn.model$degree[i], i]]
      tempi <- ArrayToHash(in.state, 3)
      new.vec[i] <- tn.model$table[tempi, i]
    }
  }
  return(new.vec)
}

############################################################

attractor.distance.summary <- function(vec0, tn.model, wt, forced.genes = NULL, forced.states = NULL, nOutcomes = 3) {
  vec.list <- cbind(NULL, vec0)

  list.pos <- 0
  list.size <- 1
  while (list.pos == 0) {
    new.vec <- apply.op(vec.list[, list.size], tn.model)
    if (!wt) {
      new.vec[forced.genes] <- forced.states
    }
    for (i in seq_len(list.size)) {
      if (sum(new.vec != vec.list[, i]) == 0) {
        list.pos <- i
      }
    }
    vec.list <- cbind(vec.list, new.vec)
    list.size <- list.size + 1
  }


  attractor <- cbind(vec0, vec.list[, (list.pos + 1):list.size]) - nOutcomes + 1
  return(list(attractor = attractor, path = vec.list - nOutcomes + 1))
}


#############################################################################################
##
## visible functions
##
#############################################################################################


attractor.2 <- function(tn.model, model.obj, wt, nOutcomes = 3) {
  n.gene <- dim(model.obj$initial.states)[1]
  n.sample <- dim(model.obj$initial.states)[2]

  attractor.matrix <- matrix(NA, n.gene, n.sample)

  for (i in seq_len(n.sample)) {
    fg <- model.obj$forced.gene.list[[i]]$forced.genes
    fs <- model.obj$forced.gene.list[[i]]$forced.states
    # vec0<-model.obj$initial.states[,i]
    vec0 <- rep(2, n.gene)
    vec0[fg] <- fs
    junk <- attractor.distance.summary(vec0, tn.model, wt, fg, fs)
    nc <- dim(junk$attractor)[2]
    if (nOutcomes == 3) {
      attractor.matrix[, i] <- summarize.attractor.2(junk$attractor[, 2:nc])
    }
    if (nOutcomes == 2) {
      attractor.matrix[, i] <- summarize.attractor.bool(junk$attractor[, 2:nc])
    }
  }

  return(attractor.matrix)
}

#######################################

attractor.2.detail <- function(net.op, net.graph, model.obj, wt) {
  n.gene <- dim(model.obj$initial.states)[1]
  n.sample <- dim(model.obj$initial.states)[2]

  junk.list <- NULL

  for (i in seq_len(n.sample)) {
    fg <- model.obj$forced.gene.list[[i]]$forced.genes
    fs <- model.obj$forced.gene.list[[i]]$forced.states
    vec0 <- model.obj$initial.states[, i]
    junk <- attractor.distance.summary(vec0, model.obj, wt, fg, fs, model.obj$nOutcomes)
    junk.list <- append(junk.list, list(junk))
  }
  return(junk.list)
}

#####################################

attractor.posterior.2 <- function(posteriorObj, model.obj, wt) {
  n.post <- dim(tableObjs(posteriorObj))[3]
  n.gene <- dim(perturbationObj(posteriorObj))[1]
  n.sample <- dim(perturbationObj(posteriorObj))[2]

  attractor.list <- NULL
  for (i in seq_len(n.sample)) {
    attractor.list <- append(attractor.list, list(NULL))
  }

  for (i in seq_len(n.sample)) {
    attractor.list[[i]] <- matrix(0, n.post, n.gene)
  }

  for (i in seq_len(n.post)) {
    tn.model <- list(
      table = tableObjs(posteriorObj)[, , i],
      graph = graphObjs(posteriorObj)[, , i],
      degree = degreeObjs(posteriorObj)[i, ]
    )

    junk <- attractor.2(tn.model, model.obj, wt)
    for (j in seq_len(n.sample)) {
      attractor.list[[j]][i, ] <- junk[, j]
    }
  }

  return(attractor.list)
}

####################################################################


graph.posterior.marginal <- function(posteriorObj) {
  n.post <- dim(tableObjs(posteriorObj))[3]
  n.gene <- dim(perturbationObj(posteriorObj))[1]
  n.sample <- dim(perturbationObj(posteriorObj))[2]


  parent.post.table <- matrix(0, n.gene, n.gene + 1)

  for (i in seq_len(n.gene)) {
    for (j in seq_len(n.post)) {
      gr <- graphObjs(posteriorObj)[, , j]

      pp <- c(gr[, i], 0, 0)[1:2]

      if (pp[1] == 0 & pp[2] == 0) {
        parent.post.table[i, pp[1] + 1] <- parent.post.table[i, pp[1] + 1] + 1
      }
      if (pp[1] + pp[2] > 0) {
        parent.post.table[i, pp[1] + 1] <- parent.post.table[i, pp[1] + 1] + 1
        parent.post.table[i, pp[2] + 1] <- parent.post.table[i, pp[2] + 1] + 1
      }
    }
  }

  parent.post.table <- parent.post.table / n.post

  return(parent.post.table)
}

####################################################################

## slot getters
setGeneric("perturbationObj", function(x) standardGeneric("perturbationObj"))
setGeneric("steadyStateObj", function(x) standardGeneric("steadyStateObj"))
setGeneric("geneNames", function(x) standardGeneric("geneNames"))
setGeneric("experimentNames", function(x) standardGeneric("experimentNames"))
setGeneric("degreeObjMin", function(x) standardGeneric("degreeObjMin"))
setGeneric("graphObjMin", function(x) standardGeneric("graphObjMin"))
setGeneric("tableObjMin", function(x) standardGeneric("tableObjMin"))
setGeneric("newScore", function(x) standardGeneric("newScore"))
setGeneric("minScore", function(x) standardGeneric("minScore"))
setGeneric("finalTemperature", function(x) standardGeneric("finalTemperature"))
setGeneric("xSeed", function(x) standardGeneric("xSeed"))
setGeneric("inputParams", function(x) standardGeneric("inputParams"))
setGeneric("scores", function(x) standardGeneric("scores"))
setGeneric("degreeObjs", function(x) standardGeneric("degreeObjs"))
setGeneric("graphObjs", function(x) standardGeneric("graphObjs"))
setGeneric("tableObjs", function(x) standardGeneric("tableObjs"))
setGeneric("perturbationType", function(x) standardGeneric("perturbationType"))
setGeneric("scoreType", function(x) standardGeneric("scoreType"))
setGeneric("backupStage", function(x) standardGeneric("backupStage"))
setGeneric("maxStage", function(x) standardGeneric("maxStage"))
setGeneric("maxTransition", function(x) standardGeneric("maxTransition"))
setGeneric("epsilon", function(x) standardGeneric("epsilon"))
setGeneric("beta0", function(x) standardGeneric("beta0"))
setGeneric("chi0", function(x) standardGeneric("chi0"))
setGeneric("delta", function(x) standardGeneric("delta"))
setGeneric("ne", function(x) standardGeneric("ne"))
setGeneric("m0", function(x) standardGeneric("m0"))
setGeneric("maxDegree", function(x) standardGeneric("maxDegree"))
setGeneric("pAddParent", function(x) standardGeneric("pAddParent"))
setGeneric("pExchangeParent", function(x) standardGeneric("pExchangeParent"))
setGeneric("neighborDegree", function(x) standardGeneric("neighborDegree"))
setGeneric("pNeighborhood", function(x) standardGeneric("pNeighborhood"))
setGeneric("rho", function(x) standardGeneric("rho"))
setGeneric("edgePenalty", function(x) standardGeneric("edgePenalty"))
setGeneric("traces", function(x) standardGeneric("traces"))
setGeneric("stageCount", function(x) standardGeneric("stageCount"))

## slot setters
setGeneric("perturbationObj<-", function(x, value) standardGeneric("perturbationObj<-"))
setGeneric("steadyStateObj<-", function(x, value) standardGeneric("steadyStateObj<-"))
setGeneric("geneNames<-", function(x, value) standardGeneric("geneNames<-"))
setGeneric("experimentNames<-", function(x, value) standardGeneric("experimentNames<-"))
setGeneric("degreeObjMin<-", function(x, value) standardGeneric("degreeObjMin<-"))
setGeneric("graphObjMin<-", function(x, value) standardGeneric("graphObjMin<-"))
setGeneric("tableObjMin<-", function(x, value) standardGeneric("tableObjMin<-"))
setGeneric("newScore<-", function(x, value) standardGeneric("newScore<-"))
setGeneric("minScore<-", function(x, value) standardGeneric("minScore<-"))
setGeneric("finalTemperature<-", function(x, value) standardGeneric("finalTemperature<-"))
setGeneric("xSeed<-", function(x, value) standardGeneric("xSeed<-"))
setGeneric("inputParams<-", function(x, value) standardGeneric("inputParams<-"))
setGeneric("scores<-", function(x, value) standardGeneric("scores<-"))
setGeneric("degreeObjs<-", function(x, value) standardGeneric("degreeObjs<-"))
setGeneric("graphObjs<-", function(x, value) standardGeneric("graphObjs<-"))
setGeneric("tableObjs<-", function(x, value) standardGeneric("tableObjs<-"))
setGeneric("perturbationType<-", function(x, value) standardGeneric("perturbationType<-"))
setGeneric("scoreType<-", function(x, value) standardGeneric("scoreType<-"))
setGeneric("backupStage<-", function(x, value) standardGeneric("backupStage<-"))
setGeneric("maxStage<-", function(x, value) standardGeneric("maxStage<-"))
setGeneric("maxTransition<-", function(x, value) standardGeneric("maxTransition<-"))
setGeneric("epsilon<-", function(x, value) standardGeneric("epsilon<-"))
setGeneric("beta0<-", function(x, value) standardGeneric("beta0<-"))
setGeneric("chi0<-", function(x, value) standardGeneric("chi0<-"))
setGeneric("delta<-", function(x, value) standardGeneric("delta<-"))
setGeneric("ne<-", function(x, value) standardGeneric("ne<-"))
setGeneric("m0<-", function(x, value) standardGeneric("m0<-"))
setGeneric("maxDegree<-", function(x, value) standardGeneric("maxDegree<-"))
setGeneric("pAddParent<-", function(x, value) standardGeneric("pAddParent<-"))
setGeneric("pExchangeParent<-", function(x, value) standardGeneric("pExchangeParent<-"))
setGeneric("neighborDegree<-", function(x, value) standardGeneric("neighborDegree<-"))
setGeneric("pNeighborhood<-", function(x, value) standardGeneric("pNeighborhood<-"))
setGeneric("rho<-", function(x, value) standardGeneric("rho<-"))
setGeneric("edgePenalty<-", function(x, value) standardGeneric("edgePenalty<-"))
setGeneric("traces<-", function(x, value) standardGeneric("traces<-"))
setGeneric("stageCount<-", function(x, value) standardGeneric("stageCount<-"))

graphPosterior <- function(tpost) {
  n.post <- dim(tableObjs(tpost))[3]
  n.gene <- dim(perturbationObj(tpost))[1]
  n.sample <- dim(perturbationObj(tpost))[2]
  parent.post.table <- matrix(0, n.gene, n.gene + 1)
  for (i in seq_len(n.gene)) {
    for (j in seq_len(n.post)) {
      gr <- graphObjs(tpost)[, , j]
      pp <- gr[1:maxDegree(inputParams(tpost)), i]
      if (all(pp == 0)) {
        parent.post.table[i, 1] <- parent.post.table[i, 1] + 1
      } else {
        for (k in seq_len(length(pp))) {
          if (pp[k] != 0) parent.post.table[i, pp[k] + 1] <- parent.post.table[i, pp[k] + 1] + 1
        }
      }
    }
  }
  parent.post.table <- parent.post.table / n.post
  if (is.null(rownames(perturbationObj(tpost)))) {
    rownames(parent.post.table) <- seq_len(nrow(parent.post.table))
    colnames(parent.post.table) <- 0:(ncol(parent.post.table) -
      1)
  }
  else {
    rownames(parent.post.table) <- rownames(perturbationObj(tpost))
    colnames(parent.post.table) <- c("-", rownames(perturbationObj(tpost)))
  }
  return(parent.post.table)
}

plotTraces <- function(tfit) {
  par(mfrow = c(2, 2))
  n <- length(traces(tfit)$muTrace)
  plot(x = 1:n, y = traces(tfit)$muTrace, type = "l", xlab = "stages", ylab = "mu", main = "muTrace")
  plot(x = 1:n, y = traces(tfit)$sigmaTrace, type = "l", xlab = "stages", ylab = "sigma", main = "sigmaTrace")
  plot(x = 1:n, y = traces(tfit)$sigmaRhoTrace, type = "l", xlab = "stages", ylab = "sigmaRho", main = "sigmaRhoTrace")
  plot(x = 1:n, y = traces(tfit)$temperatureTrace, type = "l", xlab = "stages", ylab = "temperature", main = "temperatureTrace")
}

% automatic manuscript creation for frma
% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{ternarynet: A Computational Bayesian Approach to Ternary Network Estimation}
%\VignetteDepends{ternarynet}
%\VignettePackage{ternarynet}
\documentclass[12pt]{article}
\usepackage{hyperref}
\usepackage[authoryear, round]{natbib}

\textwidth=6.2in
\textheight=8.5in
\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand\Rpackage[1]{{\textsf{#1}\index{#1 (package)}}}
\newcommand\dataset[1]{{\textit{#1}\index{#1 (data set)}}}
\newcommand\Rclass[1]{{\textit{#1}\index{#1 (class)}}}
\newcommand\Rfunction[1]{{{\small\texttt{#1}}\index{#1 (function)}}}
\newcommand\Rfunarg[1]{{\small\texttt{#1}}}
\newcommand\Robject[1]{{\small\texttt{#1}}}
\newcommand\ttt[1]{\texttt{#1}}

\author{Matthew N. McCall and Anthony Almudevar and Harry A. Stern}

\begin{document}
\title{A Computational Bayesian Approach to Ternary Network Estimation (ternarynet)}
\maketitle
\tableofcontents

\newpage

\section{Introduction}

This document describes \Rpackage{ternarynet}, which implements a
computational Bayesian algorithm to estimate a ternary network from
perturbation data. We strong recommend reading the paper,
\emph{Fitting Boolean Networks from Steady State Perturbation Data}
(Almudevar \emph{et. al} 2011) before proceeding with this vignette.

\section{Getting Started}
First begin by downloading and installing the ternarynet package.
<<echo=T,results=hide>>=
library(ternarynet)
@ 

\section*{\ttt{parallelFit} function}

The \ttt{ternarynet} package contains a parallel 
implementation of the replica exchange algorithm 
for fitting ternary network models.  The 
\ttt{parallelFit} function
takes the following arguments:

\begin{description}
    \item[\ttt{experiment\_set}]data frame containing five columns: 
        \begin{description}
            \item[\ttt{i\_exp}] an experiment index:
                an integer from 0 to $N_{\textrm{exp}}-1$,
                where $N_{\textrm{exp}}$ is the number of experiments.
            \item[\ttt{i\_node}] a node index: an integer from
                0 to $N_{\textrm{node}}-1$,
                where $N_{\textrm{node}}$ is the number of nodes.
            \item[\ttt{outcome}] a value of -1, 0, or +1, denoting a
                particular outcome for
                that node in that experiment
            \item[\ttt{value}] a cost for obtaining that outcome.
                For instance, if the cost function
                is the Hamming distance, and the observed outcome is +1,
                the cost would be would be +2, +1, or 0 for an 
                outcome of -1, 0, or +1, respectively.
            \item[\ttt{is\_perturbation}] a Boolean value 
                (or a value of 0/1) denoting whether this 
                outcome is due to an applied perturbation or not.
        \end{description}
    \item[\ttt{max\_parents}]maximum number of parents 
                                allowed for each node
    \item[\ttt{n\_cycles}]maximum number of Monte Carlo cycles
    \item[\ttt{n\_write}]number of times to write output during the run
    \item[\ttt{T\_lo}]T for lowest-temperature replica
    \item[\ttt{T\_h}]T for highest-temperature replica
    \item[\ttt{target\_score}] run will terminate if this is reached
    \item[\ttt{n\_proc}]number of replicas
    \item[\ttt{logfile}]filename for log file
    \item[\ttt{n\_thread}]number of openMP threads to run per process; default=1
    \item[\ttt{init\_parents}]initial parents; randomize if null
    \item[\ttt{init\_outcomes}]inital outcomes; set to '.' if null
    \item[\ttt{exchange\_interval}]steps between replica exchanges; default=1000
    \item[\ttt{adjust\_move\_size\_interval}]steps between 
            move size adjustments, default=7001
    \item[\ttt{max\_states}]maximum number of states to propagate
            to find a repetition; default=10
    \item[\ttt{callback}]callback function, should take one integer argument
            (the replica number), used to call set.seed with different seed
            for each replica
\end{description}

The return value is a list with an element for each replica.  Each
element is itself a list of the best unnormalized score, normalized
score (unnormalized score divided by product of number of nodes and
number of experiments), list of parents for each node, and array
describing the transition rule, giving the outcome of a node for each
possible configuration of parent nodes.

\section*{Examples}

The following shows a subset of the simple model regulatory network
given in Example 1 of Reference 1 (nodes 1-4 only).  There are four
nodes and eight experiments (the first four rows of Table 4).  
The cost function for each possible outcome is the Hamming distance 
with the observed steady-state outcome, given a persistent perturbation.
The output corresponds with the parents and transitions described on page 13
of Almudevar et al. (2011).

<<echo=T>>=

library(ternarynet)

i_exp <- as.integer(c(0,0,0, 0,0,0, 0,0,0, 0,0,0,
                        1,1,1, 1,1,1, 1,1,1, 1,1,1,
                        2,2,2, 2,2,2, 2,2,2, 2,2,2,
                        3,3,3, 3,3,3, 3,3,3, 3,3,3,
                        4,4,4, 4,4,4, 4,4,4, 4,4,4,
                        5,5,5, 5,5,5, 5,5,5, 5,5,5,
                        6,6,6, 6,6,6, 6,6,6, 6,6,6,
                        7,7,7, 7,7,7, 7,7,7, 7,7,7))

i_node <- as.integer(c(0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3))

outcome <- as.integer(c(-1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1))

value <- c(0,1,2, 0,1,2, 0,1,2, 0,1,2,
            2,1,0, 0,1,2, 0,1,2, 0,1,2,
            2,1,0, 2,1,0, 0,1,2, 0,1,2,
            2,1,0, 2,1,0, 2,1,0, 0,1,2,
            2,1,0, 2,1,0, 2,1,0, 2,1,0,
            0,1,2, 2,1,0, 2,1,0, 2,1,0,
            0,1,2, 0,1,2, 2,1,0, 2,1,0,
            0,1,2, 0,1,2, 0,1,2, 2,1,0)

is_perturbation <- 
c(TRUE,TRUE,TRUE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  TRUE,TRUE,TRUE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, TRUE,TRUE,TRUE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, TRUE,TRUE,TRUE,
    TRUE,TRUE,TRUE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  TRUE,TRUE,TRUE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, TRUE,TRUE,TRUE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, TRUE,TRUE,TRUE)

indata <- data.frame(i_exp,i_node,outcome,value,is_perturbation)

results <- parallelFit(indata,
                        max_parents=1,
                        n_cycles=100000,
                        n_write=10,
                        T_lo=0.001,
                        T_hi=2.0,
                        target_score=0,
                        n_proc=1,
                        logfile='try.log')

lowest_temp_results <- results[[1]]

print('Unnormalized score:')
print(lowest_temp_results$unnormalized_score)

print('Normalized score:')
print(lowest_temp_results$normalized_score)

print('Parents:')
print(lowest_temp_results$parents)

print('Outcomes:')
print(lowest_temp_results$outcomes)

@

Subsequent fits may be started using the network from 
a previous fit as the initial conditions,
as in the following example (the initial network in the case 
already has a score of 0).

<<echo=T>>=
results <- parallelFit(indata,
                        max_parents=1,
                        n_cycles=10,
                        n_write=10,
                        T_lo=0.001,
                        T_hi=2.0,
                        target_score=0,
                        n_proc=1,
                        logfile='try.log',
                        init_parents=lowest_temp_results$parents,
                        init_outcomes=lowest_temp_results$outcomes)

lowest_temp_results <- results[[1]]

print('Unnormalized score:')
print(lowest_temp_results$unnormalized_score)

print('Normalized score:')
print(lowest_temp_results$normalized_score)

print('Parents:')
print(lowest_temp_results$parents)

print('Outcomes:')
print(lowest_temp_results$outcomes)

@

\section{Session Info}
<<echo=T>>=
sessionInfo()
@ 

\end{document}

\name{tnetpost}
\alias{tnetpost}
\title{Ternary Network Posterior Sampling}
\description{
  This function samples from the posterior density of a ternary network based on perturbation experiments.
}
\usage{
tnetpost(tfit, mdelta=as.integer(10000), msample=as.integer(2000), temperatureScale=1.0, xSeed=NA)
}
\arguments{
  \item{tfit}{a ternaryFit object}
  \item{mdelta}{number of transitions between samples}
  \item{msample}{number of samples}
  \item{temperatureScale}{the final temperature is multipled by this
    value for sampling}
  \item{xSeed}{an integer random seed. If NA, a random seed is generated.}
}
\value{
  The function returns a ternaryPost object.
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting Boolean
  Networks from Steady State Perturbation Data, Statistical Applications
  in Genetics and Molecular Biology, 10(1): Article 47.
  }
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
rownames(ssObj) <- rownames(pObj) <- colnames(ssObj) <- colnames(pObj) <- c("Gene1","Gene2","Gene3")
tnfitObj <- tnetfit(ssObj, pObj)
tnpostObj <- tnetpost(tnfitObj, mdelta=10, msample=10)
}
\keyword{manip}

\name{ternaryFitParameters-class}
\docType{class}
\alias{class:ternaryFitParameters}
\alias{ternaryFitParameters-class}
\alias{ternaryFitParameters}
\alias{ternaryFitParameters-methods}
\alias{initialize,ternaryFitParameters-method}
\alias{show,ternaryFitParameters-method}
\alias{perturbationType}
\alias{perturbationType,ternaryFitParameters-method}
\alias{scoreType}
\alias{scoreType,ternaryFitParameters-method}
\alias{backupStage}
\alias{backupStage,ternaryFitParameters-method}
\alias{maxStage}
\alias{maxStage,ternaryFitParameters-method}
\alias{maxTransition}
\alias{maxTransition,ternaryFitParameters-method}
\alias{epsilon}
\alias{epsilon,ternaryFitParameters-method}
\alias{beta0}
\alias{beta0,ternaryFitParameters-method}
\alias{chi0}
\alias{chi0,ternaryFitParameters-method}
\alias{delta}
\alias{delta,ternaryFitParameters-method}
\alias{ne}
\alias{ne,ternaryFitParameters-method}
\alias{m0}
\alias{m0,ternaryFitParameters-method}
\alias{maxDegree}
\alias{maxDegree,ternaryFitParameters-method}
\alias{pAddParent}
\alias{pAddParent,ternaryFitParameters-method}
\alias{pExchangeParent}
\alias{pExchangeParent,ternaryFitParameters-method}
\alias{neighborDegree}
\alias{neighborDegree,ternaryFitParameters-method}
\alias{pNeighborhood}
\alias{pNeighborhood,ternaryFitParameters-method}
\alias{rho}
\alias{rho,ternaryFitParameters-method}
\alias{edgePenalty}
\alias{edgePenalty,ternaryFitParameters-method}
\alias{perturbationType<-}
\alias{perturbationType<-,ternaryFitParameters-method}
\alias{scoreType<-}
\alias{scoreType<-,ternaryFitParameters-method}
\alias{backupStage<-}
\alias{backupStage<-,ternaryFitParameters-method}
\alias{maxStage<-}
\alias{maxStage<-,ternaryFitParameters-method}
\alias{maxTransition<-}
\alias{maxTransition<-,ternaryFitParameters-method}
\alias{epsilon<-}
\alias{epsilon<-,ternaryFitParameters-method}
\alias{beta0<-}
\alias{beta0<-,ternaryFitParameters-method}
\alias{chi0<-}
\alias{chi0<-,ternaryFitParameters-method}
\alias{delta<-}
\alias{delta<-,ternaryFitParameters-method}
\alias{ne<-}
\alias{ne<-,ternaryFitParameters-method}
\alias{m0<-}
\alias{m0<-,ternaryFitParameters-method}
\alias{maxDegree<-}
\alias{maxDegree<-,ternaryFitParameters-method}
\alias{pAddParent<-}
\alias{pAddParent<-,ternaryFitParameters-method}
\alias{pExchangeParent<-}
\alias{pExchangeParent<-,ternaryFitParameters-method}
\alias{neighborDegree<-}
\alias{neighborDegree<-,ternaryFitParameters-method}
\alias{pNeighborhood<-}
\alias{pNeighborhood<-,ternaryFitParameters-method}
\alias{rho<-}
\alias{rho<-,ternaryFitParameters-method}
\alias{edgePenalty<-}
\alias{edgePenalty<-,ternaryFitParameters-method}

\title{Ternary Network Fitting Parameters}
\description{This is a class representation of the input parameters for
  the ternary network fitting algorithm implemented in the function
  \code{tnetfit}.}

\section{Creating Objects}{

  \code{
    ternaryFitParameters()
  }  

  This creates a \code{ternaryFitParameters} object with the default
  fitting parameters. 
  }
  
\section{Slots}{
  \describe{
    \item{\code{perturbationType}:}{this parameter currently can only be
  set to 1} 
    \item{\code{scoreType}:}{the method to score networks. Can be set to
  either 1 or 2, corresponding the the score types in Almudevar et
  al. (2011).} 
    \item{\code{backupStage}:}{current fit is output periodically
  according to this parameter}
    \item{\code{maxStage}:}{the maximum number of stages
  permitted. Ideally, the actual number of stages required until
  convergence should be much less than this value.} 
    \item{\code{maxTransition}:}{This parameter provides an adaptive
  truncation of the stage sample size. The stage terminates before the
  specified fixed sample size if the number of transitions resulting in
  a strict increase of the score reaches this value. If the sampler is
  in steady state, then this count should be approximately half the
  number of transitions in which the score changes value.}
    \item{\code{epsilon}:}{Convergence tolerance.}
    \item{\code{beta0}:}{Algorithm terminates when this number of
  consecutive convergence events have occurred.} 
    \item{\code{chi0}:}{The target initial acceptance rate. This should
  be close to 1, although setting it too close will increase computation
  time.}
    \item{\code{delta}:}{The increment change in steady state
  distribution between stages (as variational distance). Larger values
  tend to decrease computation time, but too large a value will result
  in spurious convergence.}
    \item{\code{ne}:}{The fixed sample size (number of MCMC transitions) per
  stage.}
    \item{\code{m0}:}{The sample size (number of transitions) used to
  determine the initial temperature.}
    \item{\code{maxDegree}:}{Maximum number of parents per node
  permitted in model topology.}
    \item{\code{pAddParent}:}{This is the probability of adding a parent
  to a randomly selected node in the proposal function.}
    \item{\code{pExchangeParent}:}{This parameter gives the probability
  of a parent exchange in the proposal function. The AddParent operation
  takes precedence, so this probability should be interpreted as being
  conditional on the rejection of the AddParent operation.}
    \item{\code{neighborDegree}:}{Number of applications of the proposal
  function.}
    \item{\code{pNeighborhood}:}{Vector of probabilities denoted, which
  generates the random number of proposal function iterations. The
  length is one less than neighborDegree. If neighborDegree equals 1
  then no iteration is performed, and this vector is ignored.}
    \item{\code{rho}:}{Weight parameter for the exponential
  smoothing of the variance estimate. For no smoothing set to 1.}
    \item{\code{edgePenalty}:}{This parameter provides a complexity
  penalty. This number times the number of edges is added to the
  score. To apply no penalty set this parameter to 0.}
  }
}

\section{Methods}{
  All named elements can be accessed and set in the standard way
  (e.g. \code{scoreType(object)} and \code{scoreType(object)<-}).
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  \code{tnetfit}, \code{ternaryFit-class}, \code{ternaryPost-class}.
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.
  }

\examples{
# create an instance
ternaryFitParameters()
}

\keyword{classes}

\name{attractorSummary}
\alias{attractorSummary}
\title{Summarize Attractors}
\description{
  This function summarizes the posterior probability of possible attractors.
}
\usage{
attractorSummary(tpost, post.prob.limit = 0.01, wildtype = TRUE)
}
\arguments{
  \item{tpost}{a ternaryPost object}
  \item{post.prob.limit}{the minimum posterior probability for an
    attractor to be listed}
  \item{wildtype}{if TRUE, the wildtype attractors are summarized; if
    FALSE, the perturbed attractors are summarized.}
}
\value{
  The function returns a matrix of attractors and posterior
  probabilities for each perturbation.
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.}
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
rownames(ssObj) <- rownames(pObj) <- colnames(ssObj) <- colnames(pObj) <- c("Gene1","Gene2","Gene3")
tnfitObj <- tnetfit(ssObj, pObj)
tnpostObj <- tnetpost(tnfitObj, mdelta=10, msample=10)
attractorSummary(tnpostObj)
}
\keyword{manip}

\name{simulateSteadyState}
\alias{simulateSteadyState}
\title{Simulate Steady State Data}
\description{
  This function generates simulated steady state data from a given network.
}
\usage{
simulateSteadyState(perturbationObj, tableObj, graphObj, degreeObj, wildtype=FALSE)
}
\arguments{
  \item{perturbationObj}{a matrix of perturbation experiments. Rows are genes and columns are experiments.}
  \item{tableObj}{a matrix containing the transition function tables}
  \item{graphObj}{a matrix containing the parents of each node}
  \item{degreeObj}{a vector containing the in-degree of each node}
  \item{wildtype}{if TRUE, the preturbations are assumed to be transient; if FALSE, the perturbations are assumed to be persistent.}
}
\value{
  The function creates a steadyStateObj.
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting Boolean
  Networks from Steady State Perturbation Data, Statistical Applications
  in Genetics and Molecular Biology, 10(1): Article 47.
  }
\examples{
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
degreeObj <- c(0,1,1)
graphObj <- matrix(nrow=1,ncol=3)
graphObj[1,1] <- 0
graphObj[1,2] <- 1
graphObj[1,3] <- 2
tableObj <- matrix(nrow=3,ncol=3)
tableObj[,1] <- rep(0,3)
tableObj[,2] <- c(-1,0,1)
tableObj[,3] <- c(-1,0,1)
ssObj <- simulateSteadyState(pObj, tableObj, graphObj, degreeObj)
}
\keyword{manip}

\name{plotFit}
\alias{plotFit}
\title{Network Fit Plot}
\description{
  This function plots the graph corresponding to the minimum scoring network.
}

\usage{
 plotFit(ternaryFit, type="interactive", ...)
}
\arguments{
  \item{ternaryFit}{a ternaryFit object}
  \item{type}{the type of plot to produce. "interactive" produces a plot
    that can be altered in the plotting window using the tkplot
    function from the igraph package. "static" produces a standard plot
    in any R graphics device.}
  \item{...}{additional parameters passed to the plotting function}
}
\value{
  A plot of the network corresponding to the minimum score (stored in the graphObjMin slot) is plotted.
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting Boolean
  Networks from Steady State Perturbation Data, Statistical Applications
  in Genetics and Molecular Biology, 10(1): Article 47.
  }
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
tnfitObj <- tnetfit(ssObj, pObj)
plotFit(tnfitObj, type="static")
}
\keyword{manip}

\name{graphPosterior}
\alias{graphPosterior}
\title{Network Topology}
\description{
  This function summarizes the topology of the ternary network using
  marginal edge probabilities.
}
\usage{
graphPosterior(tpost) 
}
\arguments{
  \item{tpost}{a ternaryPost object}
}
\value{
  The function returns a matrix of marginal posterior probabilities of
  each possible network edge -- rows are children and columns are
  parents. The first column represents no parents. 
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting Boolean
  Networks from Steady State Perturbation Data, Statistical Applications
  in Genetics and Molecular Biology, 10(1): Article 47.
  }
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
rownames(ssObj) <- rownames(pObj) <- colnames(ssObj) <- colnames(pObj) <- c("Gene1","Gene2","Gene3")
tnfitObj <- tnetfit(ssObj, pObj)
tnpostObj <- tnetpost(tnfitObj, mdelta=10, msample=10)
graphPosterior(tnpostObj)
}
\keyword{manip}

\name{tnetfit}
\alias{tnetfit}
\title{Ternary Network Fitting}
\description{
  This function fits a ternary network based on perturbation experiments.
}
\usage{
tnetfit(steadyStateObj, perturbationObj, params=ternaryFitParameters(),
xSeed=NA)
}
\arguments{
  \item{steadyStateObj}{a matrix of steady gene expression observations
    from a perturbation experiment. Rows are genes and columns are experiments.}
  \item{perturbationObj}{a matrix of perturbation experiments. Rows are
    genes and columns are experiments.}
  \item{params}{a ternaryFitParameters object}  
  \item{xSeed}{an integer random seed. If NA, a random seed is generated.}
}
\value{
  The function returns a ternaryFit object.
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.}
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
rownames(ssObj) <- rownames(pObj) <- colnames(ssObj) <- colnames(pObj) <- c("Gene1","Gene2","Gene3")
tnfitObj <- tnetfit(ssObj, pObj)
}
\keyword{manip}

\name{plotTraces}
\alias{plotTraces}
\title{Network Fit Traces}
\description{
  This function plots the trace of four model parameters. 
}
\usage{
plotTraces(tfit) 
}
\arguments{
  \item{tfit}{a ternaryFit object}
}
\value{
  The function creates a 2x2 grid of the four trace plots. 
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting Boolean
  Networks from Steady State Perturbation Data, Statistical Applications
  in Genetics and Molecular Biology, 10(1): Article 47.
  }
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
tnfitObj <- tnetfit(ssObj, pObj)
plotTraces(tnfitObj)
}
\keyword{manip}

\name{ternaryPost-class}
\docType{class}
\alias{class:ternaryPost}
\alias{ternaryPost-class}
\alias{ternaryPost}
\alias{ternaryPost-methods}
\alias{initialize,ternaryPost-method}
\alias{show,ternaryPost-method}
\alias{dim,ternaryPost-method}
\alias{perturbationObj,ternaryPost-method}
\alias{steadyStateObj,ternaryPost-method}
\alias{geneNames,ternaryPost-method}
\alias{experimentNames,ternaryPost-method}
\alias{scores}
\alias{scores,ternaryPost-method}
\alias{degreeObjs}
\alias{degreeObjs,ternaryPost-method}
\alias{graphObjs}
\alias{graphObjs,ternaryPost-method}
\alias{tableObjs}
\alias{tableObjs,ternaryPost-method}
\alias{inputParams,ternaryPost-method}
\alias{perturbationObj<-,ternaryPost-method}
\alias{steadyStateObj<-,ternaryPost-method}
\alias{geneNames<-,ternaryPost-method}
\alias{experimentNames<-,ternaryPost-method}
\alias{scores<-}
\alias{scores<-,ternaryPost-method}
\alias{degreeObjs<-}
\alias{degreeObjs<-,ternaryPost-method}
\alias{graphObjs<-}
\alias{graphObjs<-,ternaryPost-method}
\alias{tableObjs<-}
\alias{tableObjs<-,ternaryPost-method}
\alias{inputParams<-,ternaryPost-method}

\title{Ternary Network Posterior}
\description{This is a class representation of the output of the ternary
  network posterior sampling algorithm implemented in the function
  \code{tnetpost}.} 

\section{Creating Objects}{
  While one can create their own objects using the function
  \code{ternaryPost()}, this is highly discouraged. Typically this class
  is created by running the \code{tnetpost} function.
}
  
\section{Slots}{
  \describe{
    \item{\code{perturbationObj}:}{a matrix of perturbation
  experiments. Rows are genes and columns are experiments.}
    \item{\code{steadyStateObj}:}{a matrix of steady gene expression
  observations from a perturbation experiment. Rows are genes and
  columns are experiments.}
    \item{\code{geneNames}:}{a vector of gene names corresponding to the
  rows of the perturbationObj and steadyStateObj.}
    \item{\code{experimentNames}:}{a vector of experiment names
      corresponding to the columns of the perturbationObj and
      steadyStateObj.}
    \item{\code{scores}:}{the score of each sample}
    \item{\code{degreeObjs}:}{the in-degree vector for each sample}
    \item{\code{graphObjs}:}{the graph matrix for each sample}
    \item{\code{tableObjs}:}{the table matrix for each sample}
    \item{\code{inputParams}:}{the ternaryFitParameters object used}
  }
}

\section{Methods}{
  All named elements can be accessed and set in the standard way
  (e.g. \code{scores(object)} and \code{scores(object)<-}).
}

\author{Matthew N. McCall and Anthony Almudevar}

\seealso{
  \code{tnetfit}, \code{ternaryFitParameters-class}, \code{ternaryFit-class}.
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.  
} 

\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
tnfitObj <- tnetfit(ssObj, pObj)
tnpostObj <- tnetpost(tnfitObj, mdelta=10, msample=10)
class(tnpostObj)
}

\keyword{classes}

\name{ternaryFit-class}
\docType{class}
\alias{class:ternaryFit}
\alias{ternaryFit-class}
\alias{ternaryFit}
\alias{ternaryFit-methods}
\alias{initialize,ternaryFit-method}
\alias{dim,ternaryFit-method}
\alias{show,ternaryFit-method}
\alias{perturbationObj}
\alias{perturbationObj,ternaryFit-method}
\alias{steadyStateObj}
\alias{steadyStateObj,ternaryFit-method}
\alias{geneNames}
\alias{geneNames,ternaryFit-method}
\alias{experimentNames}
\alias{experimentNames,ternaryFit-method}
\alias{degreeObjMin}
\alias{degreeObjMin,ternaryFit-method}
\alias{graphObjMin}
\alias{graphObjMin,ternaryFit-method}
\alias{tableObjMin}
\alias{tableObjMin,ternaryFit-method}
\alias{newScore}
\alias{newScore,ternaryFit-method}
\alias{minScore}
\alias{minScore,ternaryFit-method}
\alias{finalTemperature}
\alias{finalTemperature,ternaryFit-method}
\alias{traces}
\alias{traces,ternaryFit-method}
\alias{stageCount}
\alias{stageCount,ternaryFit-method}
\alias{xSeed}
\alias{xSeed,ternaryFit-method}
\alias{inputParams}
\alias{inputParams,ternaryFit-method}
\alias{perturbationObj<-}
\alias{perturbationObj<-,ternaryFit-method}
\alias{steadyStateObj<-}
\alias{steadyStateObj<-,ternaryFit-method}
\alias{geneNames<-}
\alias{geneNames<-,ternaryFit-method}
\alias{experimentNames<-}
\alias{experimentNames<-,ternaryFit-method}
\alias{degreeObjMin<-}
\alias{degreeObjMin<-,ternaryFit-method}
\alias{graphObjMin<-}
\alias{graphObjMin<-,ternaryFit-method}
\alias{tableObjMin<-}
\alias{tableObjMin<-,ternaryFit-method}
\alias{newScore<-}
\alias{newScore<-,ternaryFit-method}
\alias{minScore<-}
\alias{minScore<-,ternaryFit-method}
\alias{finalTemperature<-}
\alias{finalTemperature<-,ternaryFit-method}
\alias{traces<-}
\alias{traces<-,ternaryFit-method}
\alias{stageCount<-}
\alias{stageCount<-,ternaryFit-method}
\alias{xSeed<-}
\alias{xSeed<-,ternaryFit-method}
\alias{inputParams<-}
\alias{inputParams<-,ternaryFit-method}

\title{Ternary Network Fit}
\description{This is a class representation of the output of the ternary
  network fitting algorithm implemented in the function \code{tnetfit}.}

\section{Creating Objects}{
  While one can create their own objects using the function
  \code{ternaryFit()}, this is highly discouraged. Typically this class
  is created by running the \code{tnetfit} function.
}

\section{Slots}{
  \describe{
    \item{\code{perturbationObj}:}{a matrix of perturbation
  experiments. Rows are genes and columns are experiments.}
    \item{\code{steadyStateObj}:}{a matrix of steady gene expression
  observations from a perturbation experiment. Rows are genes and
  columns are experiments.}
    \item{\code{geneNames}:}{a vector of gene names corresponding to the
  rows of the perturbationObj and steadyStateObj.}
    \item{\code{experimentNames}:}{a vector of experiment names
      corresponding to the columns of the perturbationObj and
      steadyStateObj.}
    \item{\code{degreeObjMin}:}{a vector containing the in-degree of
  each node in the fit achieving the minimum score}
    \item{\code{graphObjMin}:}{a matrix containing the parents of
  each node in the fit achieving the minimum score}
    \item{\code{tableObjMin}:}{a matrix containing the table in the fit
  achieving the minimum score} 
    \item{\code{newScore}:}{the most recent score}
    \item{\code{minScore}:}{the minimum score}
    \item{\code{finalTemperature}:}{the final value of the temperature
  parameter} 
    \item{\code{traces}:}{a dataframe contain the traces for 4 parameters}
    \item{\code{stageCount}:}{the number of stages}
    \item{\code{xSeed}:}{the random seed.}
    \item{\code{inputParams}:}{the ternaryFitParameters object used.}
  }
}

\section{Methods}{
  All named elements can be accessed and set in the standard way
  (e.g. \code{xSeed(object)} and \code{xSeed(object)<-}).
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{
  \code{tnetpost}, \code{ternaryFitParameters-class}, \code{ternaryPost-class}.
  Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.
} 

\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
tnfitObj <- tnetfit(ssObj, pObj)
class(tnfitObj)
}

\keyword{classes}

\name{predictAttractor}
\alias{predictAttractor}
\title{Predict the attractor(s) resulting from a given perturbation}
\description{
  This function computes the posterior probabilities of attractors reached for a
  given perturbation using the networks from a ternaryPost object.
}
\usage{
predictAttractor(tpost, perturbations, wildtype = TRUE, verbose = FALSE)
}
\arguments{
  \item{tpost}{a ternaryPost object}
  \item{perturbations}{a list with two elements: perturbed.genes and
    forced.states}
  \item{wildtype}{if TRUE, the wildtype attractors are summarized; if
    FALSE, the perturbed attractors are summarized.}
  \item{verbose}{if TRUE, periodic reports on progress are printed.}
}
\value{
  The function returns a list with two elements: \\
  post.prob: the posterior probability of each attractor \\
  attractor.summary: a single vector of steady states based on the
  resulting attractor
}
\author{Matthew N. McCall and Anthony Almudevar}
\seealso{Almudevar A, McCall MN, McMurray H, Land H (2011). Fitting
  Boolean Networks from Steady State Perturbation Data, Statistical
  Applications in Genetics and Molecular Biology, 10(1): Article 47.}
\examples{
ssObj <- matrix(c(1,1,1,0,1,1,0,0,1),nrow=3)
pObj <- matrix(c(1,0,0,0,1,0,0,0,1),nrow=3)
rownames(ssObj) <- rownames(pObj) <- colnames(ssObj) <- colnames(pObj) <- c("Gene1","Gene2","Gene3")
tnfitObj <- tnetfit(ssObj, pObj)
tnpostObj <- tnetpost(tnfitObj, mdelta=10, msample=10)
predictAttractor(tnpostObj, list(perturbed.genes=c(1,2),forced.states=c(1,1)))
}
\keyword{manip}

\name{parallelFit}
\alias{parallelFit}
\title{Fit ternary network models using parallel tempering}
\description{Fit ternary network models using parallel tempering}
\usage{
    parallelFit(experiment_set, 
        max_parents, 
        n_cycles, 
        n_write, 
        T_lo, 
        T_hi,
        target_score,
        n_proc,
        logfile,
        n_thread,
        init_parents,
        init_outcomes,
        exchange_interval,
        adjust_move_size_interval,
        max_states,
        callback)
}
\arguments{
    \item{experiment_set}{data frame containing five columns: 
        i_exp (experiment index), i_node (node index), outcome (-1/0/1), 
        value (cost for that outcome), is_perturbation (0 or 1)}
    \item{max_parents}{maximum number of parents allowed for each node}
    \item{n_cycles}{maximum number of Monte Carlo cycles}
    \item{n_write}{number of times to write output during the run}
    \item{T_lo}{T for lowest-temperature replica}
    \item{T_hi}{T for highest-temperature replica}
    \item{target_score}{target_score - run will terminate 
                        if this is reached}
    \item{n_proc}{number of replicas}
    \item{logfile}{filename for log file}
    \item{n_thread}{number of openMP threads to run per process; default=1}
    \item{init_parents}{initial parents; randomized if null}
    \item{init_outcomes}{initial outcomes; set to '.' if null}
    \item{exchange_interval}{steps between exchanges; default=1000}
    \item{adjust_move_size_interval}{steps between move size adjustment;
            default=7001}
    \item{max_states}{max states to propagate when testing for repetition;
            default=10}
    \item{callback}{callback function, should take one integer argument
            (the replica number), used to call set.seed with different
            seed for each replica}
}
\value{
    The return value is a list with an element for each replica.  Each
    element is itself a list of the best unnormalized score, normalized
    score (unnormalized score divided by product of number of nodes and
    number of experiments), list of parents for each node, and array
    describing the transition rule, giving the outcome of a node for each
    possible configuration of parent nodes.
}
\author{Harry A. Stern and Matthew N. McCall}
\examples{

i_exp <- as.integer(c(0,0,0, 0,0,0, 0,0,0, 0,0,0,
                        1,1,1, 1,1,1, 1,1,1, 1,1,1,
                        2,2,2, 2,2,2, 2,2,2, 2,2,2,
                        3,3,3, 3,3,3, 3,3,3, 3,3,3,
                        4,4,4, 4,4,4, 4,4,4, 4,4,4,
                        5,5,5, 5,5,5, 5,5,5, 5,5,5,
                        6,6,6, 6,6,6, 6,6,6, 6,6,6,
                        7,7,7, 7,7,7, 7,7,7, 7,7,7))

i_node <- as.integer(c(0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3,
                        0,0,0, 1,1,1, 2,2,2, 3,3,3))

outcome <- as.integer(c(-1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1,
                        -1,0,1, -1,0,1, -1,0,1, -1,0,1))

value <- c(0,1,2, 0,1,2, 0,1,2, 0,1,2,
            2,1,0, 0,1,2, 0,1,2, 0,1,2,
            2,1,0, 2,1,0, 0,1,2, 0,1,2,
            2,1,0, 2,1,0, 2,1,0, 0,1,2,
            2,1,0, 2,1,0, 2,1,0, 2,1,0,
            0,1,2, 2,1,0, 2,1,0, 2,1,0,
            0,1,2, 0,1,2, 2,1,0, 2,1,0,
            0,1,2, 0,1,2, 0,1,2, 2,1,0)

is_perturbation <- 
c(TRUE,TRUE,TRUE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  TRUE,TRUE,TRUE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, TRUE,TRUE,TRUE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, TRUE,TRUE,TRUE,
    TRUE,TRUE,TRUE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  TRUE,TRUE,TRUE, FALSE,FALSE,FALSE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, TRUE,TRUE,TRUE, FALSE,FALSE,FALSE,
    FALSE,FALSE,FALSE,  FALSE,FALSE,FALSE, FALSE,FALSE,FALSE, TRUE,TRUE,TRUE)

indata <- data.frame(i_exp,i_node,outcome,value,is_perturbation)

results <- parallelFit(indata,
                        max_parents=1,
                        n_cycles=100000,
                        n_write=10,
                        T_lo=0.001,
                        T_hi=2.0,
                        target_score=0,
                        n_proc=1,
                        logfile='try.log')

lowest_temp_results <- results[[1]]

print('Unnormalized score:')
print(lowest_temp_results$unnormalized_score)

print('Normalized score:')
print(lowest_temp_results$normalized_score)

print('Parents:')
print(lowest_temp_results$parents)

print('Outcomes:')
print(lowest_temp_results$outcomes)

}
